package html_editor_pro_5_1;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.awt.datatransfer.*;
import java.util.*;

public class cssEditor extends JFrame implements ActionListener, ClipboardOwner, ChangeListener
{
 
 //Inserimento oggetti che costituiscono l'editor css
 JPanel cssEditorPPrinc = new JPanel(new BorderLayout());
 JTabbedPane cssTabbedPane = new JTabbedPane();
 JPanel cssAttrTesto = new JPanel(new GridLayout(13,2));
 JPanel cssAttrRiq = new JPanel(new GridLayout(13,2));
 JPanel cssSfondoEAltro = new JPanel(new GridLayout(13,2));
 JPanel cssRiepilogo = new JPanel();
 JTextArea cssOutput = new JTextArea(10,70);
 JScrollPane cssOutputScroll = new JScrollPane(cssOutput);
 JTextArea cssInfo = new JTextArea();
 JButton cssInvia = new JButton("Invia a HTML (J)Editor");

 //Set di bottoni e relativi textfield per propr.testo
 JButton attrTestoB1 = new JButton("color");
 JTextField attrTestoF1 = new JTextField(10);
 JButton attrTestoB2 = new JButton("font");
 JTextField attrTestoF2 = new JTextField(10);
 JButton attrTestoB3 = new JButton("font-size");
 JTextField attrTestoF3 = new JTextField(10);
 JButton attrTestoB4 = new JButton("font-style");
 Choice attrTestoF4 = new Choice();
 JButton attrTestoB5 = new JButton("font-variant");
 Choice attrTestoF5 = new Choice();
 JButton attrTestoB6 = new JButton("font-weight");
 Choice attrTestoF6 = new Choice();
 JButton attrTestoB7 = new JButton("letter-spacing");
 JTextField attrTestoF7 = new JTextField(10);
 JButton attrTestoB8 = new JButton("line-height");
 JTextField attrTestoF8 = new JTextField(10);
 JButton attrTestoB9 = new JButton("text-decoration");
 Choice attrTestoF9 = new Choice();
 JButton attrTestoB10 = new JButton("text-indent");
 JTextField attrTestoF10 = new JTextField(10);
 JButton attrTestoB11 = new JButton("text-transfonrm");
 Choice attrTestoF11 = new Choice();
 JButton attrTestoB12 = new JButton("vertical-align");
 Choice attrTestoF12 = new Choice();
 JButton attrTestoB13 = new JButton("word-spacing");
 JTextField attrTestoF13 = new JTextField(10);
 //Array per tenere conto degli elementi attivi in prop.testo
 boolean statoAttrTesto[] = new boolean[]{false,false,false,false,false,
 false,false,false,false,false,false,false,false};
 //Vettore per estrarre i valori dagli elementi attivi
 Vector attrTestoVec = new Vector();
 JButton stringaAttrTesto[] = new JButton[]{attrTestoB1,attrTestoB2,attrTestoB3,
 attrTestoB4,attrTestoB5,attrTestoB6,attrTestoB7,attrTestoB8,attrTestoB9,
 attrTestoB10,attrTestoB11,attrTestoB12,attrTestoB13};

 //Set di bottoni e textfield per propr.sfondo e altri
 JButton attrSfondoB1 = new JButton("background");
 JTextField attrSfondoF1 = new JTextField();
 JButton attrSfondoB2 = new JButton("background-attachment");
 Choice attrSfondoF2 = new Choice();
 JButton attrSfondoB3 = new JButton("background-color");
 JTextField attrSfondoF3 = new JTextField();
 JButton attrSfondoB4 = new JButton("background-image");
 JTextField attrSfondoF4 = new JTextField();
 JButton attrSfondoB5 = new JButton("background-position");
 JTextField attrSfondoF5 = new JTextField();
 JButton attrSfondoB6 = new JButton("background-repeat");
 Choice attrSfondoF6 = new Choice();
 JButton attrSfondoB7 = new JButton("display");
 Choice attrSfondoF7 = new Choice();
 JButton attrSfondoB8 = new JButton("list-style");
 JTextField attrSfondoF8 = new JTextField();
 JButton attrSfondoB9 = new JButton("list-style-image");
 JTextField attrSfondoF9 = new JTextField();
 JButton attrSfondoB10 = new JButton("list-style-position");
 Choice attrSfondoF10 = new Choice();
 JButton attrSfondoB11 = new JButton("list-style-type");
 Choice attrSfondoF11 = new Choice();
 JButton attrSfondoB12 = new JButton("white-space");
 Choice attrSfondoF12 = new Choice();
 //Array per tenere conto degli elementi attivi in prop.testo
 boolean statoAttrSfondo[] = new boolean[]{false,false,false,false,false,
 false,false,false,false,false,false,false};
 //Vettore per estrarre i valori dagli elementi attivi
 Vector attrSfondoVec = new Vector();
 JButton stringaAttrSfondo[] = new JButton[]{attrSfondoB1,attrSfondoB2,
 attrSfondoB3,attrSfondoB4,attrSfondoB5,attrSfondoB6,attrSfondoB7,
 attrSfondoB8,attrSfondoB9,attrSfondoB10,attrSfondoB11,attrSfondoB12};

 //Set di bottoni e textfield per le prop.riquadri
 JButton attrRiqB1 = new JButton("margin");
 JTextField attrRiqF1 = new JTextField();
 JButton attrRiqB2 = new JButton("padding");
 JTextField attrRiqF2 = new JTextField();
 JButton attrRiqB3 = new JButton("border-width");
 JTextField attrRiqF3 = new JTextField();
 JButton attrRiqB4 = new JButton("border-style");
 Choice attrRiqF4 = new Choice();
 JButton attrRiqB5 = new JButton("border-color");
 JTextField attrRiqF5 = new JTextField();
 JButton attrRiqB6 = new JButton("clear");
 Choice attrRiqF6 = new Choice();
 JButton attrRiqB7 = new JButton("float");
 Choice attrRiqF7 = new Choice();
 //Il prossimo bottone serve per spiegare la sintassi da
 //inserire nei textfield
 JButton attrRiqInfos = new JButton("Informazioni sulla sintassi da usare");
 //Array per tenere conto degli elementi attivi in prop.riquadri
 boolean statoAttrRiq[] = new boolean[]{false,false,false,false,false,
 false,false};
 //Vettore per estrarre i valori dagli elementi attivi
 Vector attrRiqVec = new Vector();
 JButton stringaAttrRiq[] = new JButton[]{attrRiqB1,attrRiqB2,attrRiqB3,
 attrRiqB4,attrRiqB5,attrRiqB6,attrRiqB7};



 int a = 0;

 public cssEditor(String titolo)
 {
  super(titolo);
   attrTestoF4.add("normal");
   attrTestoF4.add("italic");
   attrTestoF4.add("oblique");
   attrTestoF5.add("normal");
   attrTestoF5.add("small-caps");
   attrTestoF6.add("normal");
   attrTestoF6.add("bold");
   attrTestoF6.add("bolder");
   attrTestoF6.add("lighter");
   attrTestoF6.add("100");
   attrTestoF6.add("200");
   attrTestoF6.add("300");
   attrTestoF6.add("400");
   attrTestoF6.add("500");
   attrTestoF6.add("600");
   attrTestoF6.add("700");
   attrTestoF6.add("800");
   attrTestoF6.add("900");
   attrTestoF9.add("none");
   attrTestoF9.add("underline");
   attrTestoF9.add("overline");
   attrTestoF9.add("line-through");
   attrTestoF9.add("blink");
   attrTestoF11.add("capitalize");
   attrTestoF11.add("uppercase");
   attrTestoF11.add("lowercase");
   attrTestoF11.add("none");
   attrTestoF12.add("baseline");
   attrTestoF12.add("sub");
   attrTestoF12.add("super");
   attrTestoF12.add("top");
   attrTestoF12.add("text-top");
   attrTestoF12.add("middle");
   attrTestoF12.add("bottom");
   attrTestoF12.add("text-bottom");
   attrSfondoF2.add("scroll");
   attrSfondoF2.add("fixed");
   attrSfondoF6.add("repeat");
   attrSfondoF6.add("repeat-x");
   attrSfondoF6.add("repeat-y");
   attrSfondoF6.add("no-repeat");
   attrSfondoF7.add("block");
   attrSfondoF7.add("inline");
   attrSfondoF7.add("list-item");
   attrSfondoF7.add("none");
   attrSfondoF10.add("inside");
   attrSfondoF10.add("outside");
   attrSfondoF11.add("disc");
   attrSfondoF11.add("circle");
   attrSfondoF11.add("square");
   attrSfondoF11.add("decimal");
   attrSfondoF11.add("lower-roman");
   attrSfondoF11.add("upper-roman");
   attrSfondoF11.add("lower-alpha");
   attrSfondoF11.add("upper-alpha");
   attrSfondoF11.add("none");
   attrSfondoF12.add("normal");
   attrSfondoF12.add("pre");
   attrSfondoF12.add("nowrap");
   attrRiqF4.add("none");
   attrRiqF4.add("dotted");
   attrRiqF4.add("dashed");
   attrRiqF4.add("solid");
   attrRiqF4.add("double");
   attrRiqF4.add("groove");
   attrRiqF4.add("ridge");
   attrRiqF4.add("inset");
   attrRiqF4.add("outset");
   attrRiqF6.add("none");
   attrRiqF6.add("left");
   attrRiqF6.add("right");
   attrRiqF6.add("both");
   attrRiqF7.add("left");
   attrRiqF7.add("right");
   attrRiqF7.add("none");

   //Aggiungo gli elementi al vettore attributi testo
   attrTestoVec.addElement(attrTestoF1);
   attrTestoVec.addElement(attrTestoF2);
   attrTestoVec.addElement(attrTestoF3);
   attrTestoVec.addElement(attrTestoF4);
   attrTestoVec.addElement(attrTestoF5);
   attrTestoVec.addElement(attrTestoF6);
   attrTestoVec.addElement(attrTestoF7);
   attrTestoVec.addElement(attrTestoF8);
   attrTestoVec.addElement(attrTestoF9);
   attrTestoVec.addElement(attrTestoF10);
   attrTestoVec.addElement(attrTestoF11);
   attrTestoVec.addElement(attrTestoF12);
   attrTestoVec.addElement(attrTestoF13);

   //Aggiungo gli elementi al vettore attributi sfondo
   attrSfondoVec.addElement(attrSfondoF1);
   attrSfondoVec.addElement(attrSfondoF2);
   attrSfondoVec.addElement(attrSfondoF3);
   attrSfondoVec.addElement(attrSfondoF4);
   attrSfondoVec.addElement(attrSfondoF5);
   attrSfondoVec.addElement(attrSfondoF6);
   attrSfondoVec.addElement(attrSfondoF7);
   attrSfondoVec.addElement(attrSfondoF8);
   attrSfondoVec.addElement(attrSfondoF9);
   attrSfondoVec.addElement(attrSfondoF10);
   attrSfondoVec.addElement(attrSfondoF11);
   attrSfondoVec.addElement(attrSfondoF12);

   //Aggiungo gli elementi al vettore attributi riquadri
   attrRiqVec.addElement(attrRiqF1);
   attrRiqVec.addElement(attrRiqF2);
   attrRiqVec.addElement(attrRiqF3);
   attrRiqVec.addElement(attrRiqF4);
   attrRiqVec.addElement(attrRiqF5);
   attrRiqVec.addElement(attrRiqF6);
   attrRiqVec.addElement(attrRiqF7);


   //Actionlistener per attrTesto
   attrTestoB1.addActionListener(this);
   attrTestoB2.addActionListener(this);
   attrTestoB3.addActionListener(this);
   attrTestoB4.addActionListener(this);
   attrTestoB5.addActionListener(this);
   attrTestoB6.addActionListener(this);
   attrTestoB7.addActionListener(this);
   attrTestoB8.addActionListener(this);
   attrTestoB9.addActionListener(this);
   attrTestoB10.addActionListener(this);
   attrTestoB11.addActionListener(this);
   attrTestoB12.addActionListener(this);
   attrTestoB13.addActionListener(this);
   //Elementi a destra disattivati di default
   attrTestoF1.setEnabled(false);
   attrTestoF2.setEnabled(false);
   attrTestoF3.setEnabled(false);
   attrTestoF4.setEnabled(false);
   attrTestoF5.setEnabled(false);
   attrTestoF6.setEnabled(false);
   attrTestoF7.setEnabled(false);
   attrTestoF8.setEnabled(false);
   attrTestoF9.setEnabled(false);
   attrTestoF10.setEnabled(false);
   attrTestoF11.setEnabled(false);
   attrTestoF12.setEnabled(false);
   attrTestoF13.setEnabled(false);

   //Actionlistener per i bottoni attr.sfondo
   attrSfondoB1.addActionListener(this);
   attrSfondoB2.addActionListener(this);
   attrSfondoB3.addActionListener(this);
   attrSfondoB4.addActionListener(this);
   attrSfondoB5.addActionListener(this);
   attrSfondoB6.addActionListener(this);
   attrSfondoB7.addActionListener(this);
   attrSfondoB8.addActionListener(this);
   attrSfondoB9.addActionListener(this);
   attrSfondoB10.addActionListener(this);
   attrSfondoB11.addActionListener(this);
   attrSfondoB12.addActionListener(this);

   cssInvia.addActionListener(this);

   //Elementi a destra disattivati di default
   attrSfondoF1.setEnabled(false);
   attrSfondoF2.setEnabled(false);
   attrSfondoF3.setEnabled(false);
   attrSfondoF4.setEnabled(false);
   attrSfondoF5.setEnabled(false);
   attrSfondoF6.setEnabled(false);
   attrSfondoF7.setEnabled(false);
   attrSfondoF8.setEnabled(false);
   attrSfondoF9.setEnabled(false);
   attrSfondoF10.setEnabled(false);
   attrSfondoF11.setEnabled(false);
   attrSfondoF12.setEnabled(false);

   //Actionlistener per i bottoni attr.riquadro
   attrRiqB1.addActionListener(this);
   attrRiqB2.addActionListener(this);
   attrRiqB3.addActionListener(this);
   attrRiqB4.addActionListener(this);
   attrRiqB5.addActionListener(this);
   attrRiqB6.addActionListener(this);
   attrRiqB7.addActionListener(this);
   attrRiqInfos.addActionListener(this);
   //Elementi a destra disattivati di default
   attrRiqF1.setEnabled(false);
   attrRiqF2.setEnabled(false);
   attrRiqF3.setEnabled(false);
   attrRiqF4.setEnabled(false);
   attrRiqF5.setEnabled(false);
   attrRiqF6.setEnabled(false);
   attrRiqF7.setEnabled(false);

   //SingleSelectionModel cssSelMod = cssTabbedPane.getModel();
   //JOptionPane.showMessageDialog(null,""+cssSelModIndx);
   cssTabbedPane.addChangeListener(this);


   cssInfo.setText("Per scegliere quale attributi inserire cliccare su uno "+
   "dei bottoni nella parte destra di ogni pannello.\nSi attiveranno i relativi "+
   "campi o menu a tendina in cui si potra' inserire o scegliere un valore.\n"+
   "Per vedere un riepilogo degli attributi e confermarli scegliere il pannello "+
   "'Riepilogo e conferma'.\nDa qui sara' possibile inviare il codice del css"+
   " ad HTML (J)Editor");
   cssInfo.setFont(new Font(cssInfo.getFont().getFontName(), Font.BOLD, cssInfo.getFont().getSize()));
   cssInfo.setEditable(false);
   cssInfo.setLineWrap(true);
   cssInfo.setBackground(cssEditorPPrinc.getBackground());

   cssOutput.setLineWrap(true);
   cssOutput.setFont(new Font("Courier new", Font.PLAIN, 14));

   cssTabbedPane.add("Attributi del testo", cssAttrTesto);
   cssTabbedPane.add("Attributi riquadri", cssAttrRiq);
   cssTabbedPane.add("Sfondo e altri", cssSfondoEAltro);
   cssTabbedPane.add("Riepilogo e conferma", cssRiepilogo);

   cssEditorPPrinc.add("North", cssInfo);
   cssEditorPPrinc.add("Center", cssTabbedPane);
   cssEditorPPrinc.add("South", cssInvia);
   //Riempimento GridLayout attributi riquadri
   cssAttrRiq.add(attrRiqB1);
   cssAttrRiq.add(attrRiqF1);
   cssAttrRiq.add(attrRiqB2);
   cssAttrRiq.add(attrRiqF2);
   cssAttrRiq.add(attrRiqB3);
   cssAttrRiq.add(attrRiqF3);
   cssAttrRiq.add(attrRiqB4);
   cssAttrRiq.add(attrRiqF4);
   cssAttrRiq.add(attrRiqB5);
   cssAttrRiq.add(attrRiqF5);
   cssAttrRiq.add(attrRiqB6);
   cssAttrRiq.add(attrRiqF6);
   cssAttrRiq.add(attrRiqB7);
   cssAttrRiq.add(attrRiqF7);
   cssAttrRiq.add(attrRiqInfos);
   //Riempimento GridLayout attributi sfondo e altri
   cssSfondoEAltro.add(attrSfondoB1);
   cssSfondoEAltro.add(attrSfondoF1);
   cssSfondoEAltro.add(attrSfondoB2);
   cssSfondoEAltro.add(attrSfondoF2);
   cssSfondoEAltro.add(attrSfondoB3);
   cssSfondoEAltro.add(attrSfondoF3);
   cssSfondoEAltro.add(attrSfondoB4);
   cssSfondoEAltro.add(attrSfondoF4);
   cssSfondoEAltro.add(attrSfondoB5);
   cssSfondoEAltro.add(attrSfondoF5);
   cssSfondoEAltro.add(attrSfondoB6);
   cssSfondoEAltro.add(attrSfondoF6);
   cssSfondoEAltro.add(attrSfondoB7);
   cssSfondoEAltro.add(attrSfondoF7);
   cssSfondoEAltro.add(attrSfondoB8);
   cssSfondoEAltro.add(attrSfondoF8);
   cssSfondoEAltro.add(attrSfondoB9);
   cssSfondoEAltro.add(attrSfondoF9);
   cssSfondoEAltro.add(attrSfondoB10);
   cssSfondoEAltro.add(attrSfondoF10);
   cssSfondoEAltro.add(attrSfondoB11);
   cssSfondoEAltro.add(attrSfondoF11);
   cssSfondoEAltro.add(attrSfondoB12);
   cssSfondoEAltro.add(attrSfondoF12);
      //Riempimento GridLayout attributi del testo
   //Messo in fondo x problemi di grafica!!!
   cssAttrTesto.add(attrTestoB1);
   cssAttrTesto.add(attrTestoF1);
   cssAttrTesto.add(attrTestoB2);
   cssAttrTesto.add(attrTestoF2);
   cssAttrTesto.add(attrTestoB3);
   cssAttrTesto.add(attrTestoF3);
   cssAttrTesto.add(attrTestoB4);
   cssAttrTesto.add(attrTestoF4);
   cssAttrTesto.add(attrTestoB5);
   cssAttrTesto.add(attrTestoF5);
   cssAttrTesto.add(attrTestoB6);
   cssAttrTesto.add(attrTestoF6);
   cssAttrTesto.add(attrTestoB7);
   cssAttrTesto.add(attrTestoF7);
   cssAttrTesto.add(attrTestoB8);
   cssAttrTesto.add(attrTestoF8);
   cssAttrTesto.add(attrTestoB9);
   cssAttrTesto.add(attrTestoF9);
   cssAttrTesto.add(attrTestoB10);
   cssAttrTesto.add(attrTestoF10);
   cssAttrTesto.add(attrTestoB11);
   cssAttrTesto.add(attrTestoF11);
   cssAttrTesto.add(attrTestoB12);
   cssAttrTesto.add(attrTestoF12);
   cssAttrTesto.add(attrTestoB13);
   cssAttrTesto.add(attrTestoF13);

   //cssOutput.setText("Ciao");
   cssOutput.setLineWrap(true);
   cssOutputScroll.setAutoscrolls(true);
   cssRiepilogo.add(cssOutputScroll);

   setContentPane(cssEditorPPrinc);


   //JOptionPane.showMessageDialog(null,"JCssEditor");
   

 }//Fine public cssEditor(String titolo)



 public static void main (String[] args)
  {
   JFrame cssEditorFrame = new cssEditor("AlexMfM's (J)CssEditor Ver 0.1 for (J)Editor Ver 5.1 - Build 95");
   WindowListener wl = new WindowAdapter()

   {public void windowClosing(WindowEvent e)
   {System.exit(0);}};
   cssEditorFrame.setSize(600,500);
   cssEditorFrame.move((int)((Toolkit.getDefaultToolkit().getScreenSize().getWidth()/2)-(600/2)),(int)((Toolkit.getDefaultToolkit().getScreenSize().getHeight()/2)-(500/2)));
   cssEditorFrame.show(true);
   cssEditorFrame.addWindowListener(wl);
   
   }//Fine public static void main(String[] args)

  public void actionPerformed(ActionEvent evento)
 {
  Object sorgente = evento.getSource();

  if(sorgente==attrTestoB1)
  {
   attrTestoF1.setEnabled(!attrTestoF1.isEnabled());
   statoAttrTesto[0] = !statoAttrTesto[0];
   attrTestoF1.requestFocus();
  }
  if(sorgente==attrTestoB2)
  {
   attrTestoF2.setEnabled(!attrTestoF2.isEnabled());
   statoAttrTesto[1] = !statoAttrTesto[1];
   attrTestoF2.requestFocus();
  }
  if(sorgente==attrTestoB3)
  {
   attrTestoF3.setEnabled(!attrTestoF3.isEnabled());
   statoAttrTesto[2] = !statoAttrTesto[2];
   attrTestoF3.requestFocus();
  }
  if(sorgente==attrTestoB4)
  {
   attrTestoF4.setEnabled(!attrTestoF4.isEnabled());
   statoAttrTesto[3] = !statoAttrTesto[3];
   attrTestoF4.requestFocus();
  }
  if(sorgente==attrTestoB5)
  {
   attrTestoF5.setEnabled(!attrTestoF5.isEnabled());
   statoAttrTesto[4] = !statoAttrTesto[4];
   attrTestoF5.requestFocus();
  }
  if(sorgente==attrTestoB6)
  {
   attrTestoF6.setEnabled(!attrTestoF6.isEnabled());
   statoAttrTesto[5] = !statoAttrTesto[5];
   attrTestoF6.requestFocus();
  }
  if(sorgente==attrTestoB7)
  {
   attrTestoF7.setEnabled(!attrTestoF7.isEnabled());
   statoAttrTesto[6] = !statoAttrTesto[6];
   attrTestoF7.requestFocus();
  }
  if(sorgente==attrTestoB8)
  {
   attrTestoF8.setEnabled(!attrTestoF8.isEnabled());
   statoAttrTesto[7] = !statoAttrTesto[7];
   attrTestoF8.requestFocus();
  }
  if(sorgente==attrTestoB9)
  {
   attrTestoF9.setEnabled(!attrTestoF9.isEnabled());
   statoAttrTesto[8] = !statoAttrTesto[8];
   attrTestoF9.requestFocus();
  }
  if(sorgente==attrTestoB10)
  {
   attrTestoF10.setEnabled(!attrTestoF10.isEnabled());
   statoAttrTesto[9] = !statoAttrTesto[9];
   attrTestoF10.requestFocus();
  }
  if(sorgente==attrTestoB11)
  {
   attrTestoF11.setEnabled(!attrTestoF11.isEnabled());
   statoAttrTesto[10] = !statoAttrTesto[10];
   attrTestoF11.requestFocus();
  }
  if(sorgente==attrTestoB12)
  {
   attrTestoF12.setEnabled(!attrTestoF12.isEnabled());
   statoAttrTesto[11] = !statoAttrTesto[11];
   attrTestoF12.requestFocus();
  }
  if(sorgente==attrTestoB13)
  {
   attrTestoF13.setEnabled(!attrTestoF13.isEnabled());
   statoAttrTesto[12] = !statoAttrTesto[12];
   attrTestoF13.requestFocus();
  }
  if(sorgente==attrSfondoB1)
  {
   attrSfondoF1.setEnabled(!attrSfondoF1.isEnabled());
   statoAttrSfondo[0] = !statoAttrSfondo[0];
   attrSfondoF1.requestFocus();
  }
  if(sorgente==attrSfondoB2)
  {
   attrSfondoF2.setEnabled(!attrSfondoF2.isEnabled());
   statoAttrSfondo[1] = !statoAttrSfondo[1];
   attrSfondoF2.requestFocus();
  }
  if(sorgente==attrSfondoB3)
  {
   attrSfondoF3.setEnabled(!attrSfondoF3.isEnabled());
   statoAttrSfondo[2] = !statoAttrSfondo[2];
   attrSfondoF3.requestFocus();
  }
  if(sorgente==attrSfondoB4)
  {
   attrSfondoF4.setEnabled(!attrSfondoF4.isEnabled());
   statoAttrSfondo[3] = !statoAttrSfondo[3];
   attrSfondoF4.requestFocus();
  }
  if(sorgente==attrSfondoB5)
  {
   attrSfondoF5.setEnabled(!attrSfondoF5.isEnabled());
   statoAttrSfondo[4] = !statoAttrSfondo[4];
   attrSfondoF5.requestFocus();
  }
  if(sorgente==attrSfondoB6)
  {
   attrSfondoF6.setEnabled(!attrSfondoF6.isEnabled());
   statoAttrSfondo[5] = !statoAttrSfondo[5];
   attrSfondoF6.requestFocus();
  }
  if(sorgente==attrSfondoB7)
  {
   attrSfondoF7.setEnabled(!attrSfondoF7.isEnabled());
   statoAttrSfondo[6] = !statoAttrSfondo[6];
   attrSfondoF7.requestFocus();
  }
  if(sorgente==attrSfondoB8)
  {
   attrSfondoF8.setEnabled(!attrSfondoF8.isEnabled());
   statoAttrSfondo[7] = !statoAttrSfondo[7];
   attrSfondoF8.requestFocus();
  }
  if(sorgente==attrSfondoB9)
  {
   attrSfondoF9.setEnabled(!attrSfondoF9.isEnabled());
   statoAttrSfondo[8] = !statoAttrSfondo[8];
   attrSfondoF9.requestFocus();
  }
  if(sorgente==attrSfondoB10)
  {
   attrSfondoF10.setEnabled(!attrSfondoF10.isEnabled());
   statoAttrSfondo[9] = !statoAttrSfondo[9];
   attrSfondoF10.requestFocus();
  }
  if(sorgente==attrSfondoB11)
  {
   attrSfondoF11.setEnabled(!attrSfondoF11.isEnabled());
   statoAttrSfondo[10] = !statoAttrSfondo[10];
   attrSfondoF11.requestFocus();
  }
  if(sorgente==attrSfondoB12)
  {
   attrSfondoF12.setEnabled(!attrSfondoF12.isEnabled());
   statoAttrSfondo[11] = !statoAttrSfondo[11];
   attrSfondoF12.requestFocus();
  }
  if(sorgente==attrRiqB1)
  {
   attrRiqF1.setEnabled(!attrRiqF1.isEnabled());
   statoAttrRiq[0] = !statoAttrRiq[0];
   attrRiqF1.requestFocus();
  }
  if(sorgente==attrRiqB2)
  {
   attrRiqF2.setEnabled(!attrRiqF2.isEnabled());
   statoAttrRiq[1] = !statoAttrRiq[1];
   attrRiqF2.requestFocus();
  }
  if(sorgente==attrRiqB3)
  {
   attrRiqF3.setEnabled(!attrRiqF3.isEnabled());
   statoAttrRiq[2] = !statoAttrRiq[2];
   attrRiqF3.requestFocus();
  }
  if(sorgente==attrRiqB4)
  {
   attrRiqF4.setEnabled(!attrRiqF4.isEnabled());
   statoAttrRiq[3] = !statoAttrRiq[3];
   attrRiqF4.requestFocus();
  }
  if(sorgente==attrRiqB5)
  {
   attrRiqF5.setEnabled(!attrRiqF5.isEnabled());
   statoAttrRiq[4] = !statoAttrRiq[4];
   attrRiqF5.requestFocus();
  }
  if(sorgente==attrRiqB6)
  {
   attrRiqF6.setEnabled(!attrRiqF6.isEnabled());
   statoAttrRiq[5] = !statoAttrRiq[5];
   attrRiqF6.requestFocus();
  }
  if(sorgente==attrRiqB7)
  {
   attrRiqF7.setEnabled(!attrRiqF7.isEnabled());
   statoAttrRiq[6] = !statoAttrRiq[6];
   attrRiqF7.requestFocus();
  }
  if(sorgente==attrRiqInfos)
  {
   infoCssSintax();
  }
  if(sorgente==cssInvia)
  {
   //JOptionPane.showMessageDialog(null,"Invia a (HTML (J)Editor");
   cssInviaEditor();
  }

 }//Fine public void actionPerformed(ActionEvent evento)

 JTextArea infoCssTxtArea = new JTextArea();
 String infoCssString = new String("Cosa inserire dentro i text field:\n\n"+
 "margin: una lunghezza in pixel (es. 10px), una percentuale o 'auto'\n\n"+
 "padding: una lunghezza in pixel o una percentuale\n\n"+
 "border-width: 'thin', 'medium', 'thick' o una lunghezza\n\n");

 public void infoCssSintax()
 {
  //JOptionPane.showMessageDialog(null,"infoCssSintax()");
  JFrame infoCssFrame = new JFrame("Informazioni sulla sintassi");
  JPanel infoCssPanel = new JPanel(new BorderLayout());
  infoCssTxtArea.setText(infoCssString);
  infoCssTxtArea.setEditable(false);
  infoCssTxtArea.setBackground(infoCssPanel.getBackground());
  infoCssTxtArea.setFont(new Font(infoCssTxtArea.getFont().getFontName(),Font.BOLD,infoCssTxtArea.getFont().getSize()));
  infoCssPanel.add("Center",infoCssTxtArea);
  infoCssFrame.setContentPane(infoCssPanel);
  //guida_frame.resize(540,300);
  Dimension dim_schermo = Toolkit.getDefaultToolkit().getScreenSize();
  infoCssFrame.reshape((int)((dim_schermo.getWidth()/2)-(400/2)),(int)((dim_schermo.getHeight()/2)-150),
  400,150);
  infoCssFrame.validate();
  infoCssFrame.setVisible(true);

 }

 public void lostOwnership(Clipboard clip, Transferable contents)
  {}

  int cssSelIndx;

 public void stateChanged(ChangeEvent chEv)
 {
  //I seguenti dovrebbero evitare problemi nella visualizzazione
  //quando si cambia pannello, ma i pannelli non si updatano...
  cssTabbedPane.validate();
  cssTabbedPane.updateUI();
  cssTabbedPane.revalidate();

  Object chSorgente = chEv.getSource();
  if(chSorgente==cssTabbedPane)
  {
   cssSelIndx = cssTabbedPane.getSelectedIndex();
   if(cssSelIndx==3)
   {
    //JOptionPane.showMessageDialog(null,"Terzo tab");
    riepiloga();
   }

  }
 } //Fine stateChanged()

 int b;
 int c;
 int d;
 String stringaRiepilogo = new String();

 public void riepiloga()
 {
  //JOptionPane.showMessageDialog(null,"Terzo tab");

  //Faccio il giro degli array per vedere quali sono gli elementi true
  //Per quelli true, prendo il corrispondente elemento nel vector e
  //lo metto nella stringa di supporto
  for(b=0;b<statoAttrTesto.length;b++)
  {
   if(statoAttrTesto[b]==true)
   {
    //JOptionPane.showMessageDialog(null,"Elemento "+b+" true");
    Class tipoElemento = attrTestoVec.elementAt(b).getClass();
    /*JOptionPane.showMessageDialog(null,"Elemento "+b+" appartiene\n"+
    "alla classe "+tipoElemento.getName()); */
    if(tipoElemento.getName()=="javax.swing.JTextField")
    {
     JTextField tempField = (JTextField)attrTestoVec.elementAt(b);
     //JOptionPane.showMessageDialog(null,stringaAttrTesto[b].getText()+":"+tempField.getText());
     stringaRiepilogo = stringaRiepilogo+stringaAttrTesto[b].getText()+":"+tempField.getText()+";";
    }
    if(tipoElemento.getName()=="java.awt.Choice")
    {
     Choice tempField = (Choice)attrTestoVec.elementAt(b);
     //JOptionPane.showMessageDialog(null,stringaAttrTesto[b].getText()+":"+tempField.getSelectedItem());
     stringaRiepilogo = stringaRiepilogo+stringaAttrTesto[b].getText()+":"+tempField.getSelectedItem()+";";
     //JOptionPane.showMessageDialog(null,stringaRiepilogo);
    }

   }//Fine if sullo stato di attrTesto

  }//Fine for su attrTesto

  for(c=0;c<statoAttrRiq.length;c++)
  {
   if(statoAttrRiq[c]==true)
   {
    Class tipoElemento2 = attrRiqVec.elementAt(c).getClass();
    if(tipoElemento2.getName()=="javax.swing.JTextField")
    {
    JTextField tempField2 = (JTextField)attrRiqVec.elementAt(c);
    stringaRiepilogo = stringaRiepilogo+stringaAttrRiq[c].getText()+":"+tempField2.getText()+";";
    }
    if(tipoElemento2.getName()=="java.awt.Choice")
    {
     Choice tempField2 = (Choice)attrRiqVec.elementAt(c);
     stringaRiepilogo = stringaRiepilogo+stringaAttrRiq[c].getText()+":"+tempField2.getSelectedItem()+";";
     //JOptionPane.showMessageDialog(null,stringaRiepilogo);
    }
   }//Fine if sullo stato di attrRiq
  }//Fine for su attrRiq

  for(d=0;d<statoAttrSfondo.length;d++)
  {
   if(statoAttrSfondo[d]==true)
   {
    Class tipoElemento3 = attrSfondoVec.elementAt(d).getClass();
    if(tipoElemento3.getName()=="javax.swing.JTextField")
    {
    JTextField tempField3 = (JTextField)attrSfondoVec.elementAt(d);
    stringaRiepilogo = stringaRiepilogo+stringaAttrSfondo[d].getText()+":"+tempField3.getText()+";";
    }
    if(tipoElemento3.getName()=="java.awt.Choice")
    {
     Choice tempField3 = (Choice)attrSfondoVec.elementAt(d);
     stringaRiepilogo = stringaRiepilogo+stringaAttrSfondo[d].getText()+":"+tempField3.getSelectedItem()+";";
     //JOptionPane.showMessageDialog(null,stringaRiepilogo);
    }
   }//Fine if sullo stato di attrRiq
  }//Fine for su attrRiq

  cssOutput.setText(stringaRiepilogo);

 }

  public void cssInviaEditor()
  {
   //JOptionPane.showMessageDialog(null,"Invia");

   String da_copiare = cssOutput.getText();
   StringSelection trans = new StringSelection(da_copiare);
   Cboard.clip.setContents(trans, this);
   Editor.incolla();
   this.hide();

  }




}//Fine public class cssEditor
